package com.sheelapps.swtml.examples.texteditor;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Widget;

public class StyleListener implements Listener {
	
	public void handleEvent(Event event) {
		Widget widget = event.widget;
		Point sel = TextEditor.getStyledText().getSelectionRange();
		if ((sel == null) || (sel.y == 0))
			return;
		StyleRange style;
		for (int i = sel.x; i < sel.x + sel.y; i++) {
			StyleRange range = TextEditor.getStyledText().getStyleRangeAtOffset(i);
			if (range != null) {
				style = (StyleRange) range.clone();
				style.start = i;
				style.length = 1;
			} else {
				style = new StyleRange(i, 1, null, null, SWT.NORMAL);
			}
			if (widget == TextEditor.getButton("bold")) {
				style.fontStyle ^= SWT.BOLD;
			} else if (widget == TextEditor.getButton("italic")) {
				style.fontStyle ^= SWT.ITALIC;
			} else if (widget == TextEditor.getButton("underline")) {
				style.underline = !style.underline;
			} else if (widget == TextEditor.getButton("strikeout")) {
				style.strikeout = !style.strikeout;
			}
			TextEditor.getStyledText().setStyleRange(style);
		}
		TextEditor.getStyledText().setSelectionRange(sel.x + sel.y, 0);
	
	}

	
}
